#include "LiquidCrystal.h"
//                 RS   E    D0   D1   D2   D3
LiquidCrystal lcd(PB8, PB9, PB4, PB5, PB6, PB7);

bool update_lcd = false;
bool flip_msg = false;
const char *msg1 = "Watch this...";
const char *msg2 = "Hello World! ";

void setup()
{
  lcd.begin(16,2);
  pinMode(LED_BUILTIN, OUTPUT);
}

void loop()
{
  if (update_lcd)
  {
    update_lcd = false; 
    lcd.setCursor(0, 0);
    if (flip_msg)
    {
      lcd.print(msg2);
    }
    else
    {
      lcd.print(msg1);
    }
    lcd.setCursor(0, 1);
    if (flip_msg)
    {
      lcd.print(msg1);
    }
    else
    {
      lcd.print(msg2);
    }
  }
}

void HAL_SYSTICK_Callback(void)
{
  // blink the LED and update the LCD display
  static volatile uint32_t led_count = 0;
  static volatile uint8_t led_state = 0;
  if (led_count++ >= 1500)
  {
    led_count = 0;
    led_state = 1 - led_state;
    digitalWrite(LED_BUILTIN, led_state);
    update_lcd = true;
    flip_msg = led_state;
  }
}
